//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadxpstoimageDll()
{
	m_hinstLib = LoadLibrary("xpstoimage.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	pMSetParam = (MSetParam *)GetProcAddress(m_hinstLib, "MSetParam");
	if( pMSetParam == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreexpstoimageDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreexpstoimageDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}                 
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadxpstoimageDll() == FALSE ){
		ShowMessage("Load xpstoimage.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_TIF;
		long bitcount = BITCOUNT_24;
		long quality = 75;
		long rotate = 0;
		long width = 0;
		long height = 0;
		long xdpi = 150;
		long ydpi = 150;

		long compression = COMPRESSION_LZW;
		long multipage = 1;

		//Set Output image param
		pMSetParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to tiff file (multiple page)
		pMConvert(id,"test.xps","","multiple");
		pMEnd(id);
	}		

	FreexpstoimageDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadxpstoimageDll() == FALSE ){
		ShowMessage("Load xpstoimage.dll failed!");
		return;
	}

	long id = pMBegin();
	if(id>0){
		long imagetype = IMAGE_FORMAT_JPG;
		long bitcount = BITCOUNT_8G;//256 color grayscale( 8 bits )
		long quality = 85;
		long rotate = 90;
		long width = 1000;
		long height = 800;
		long xdpi = 200;
		long ydpi = 200;
		//only for tiff
		long compression = 0;
		long multipage = 0;

		//Set Output image param
		pMSetParam( id,imagetype,bitcount,quality,rotate,width,height,xdpi,ydpi,compression,multipage);

		//Convert to jpg file
		pMConvert(id,"test.xps","path","jpg");
		pMEnd(id);
	}

	FreexpstoimageDll();
	ShowMessage("Convert finished!");
}
//---------------------------------------------------------------------------
